import unittest
from cli import Controller
from wsgiref.simple_server import make_server
import serve

class TestController(unittest.TestCase):

    def setUp(self):
        self.controller = Controller()

    def test_read_options_commands(self):
        """tests a properly created dict"""
        result = self.controller.read_options_commands()
        assert result
        assert type(result) == type({})

    def tearDown(self):
        pass

class TestIndex(unittest.TestCase):
    def test_index(self):
        """Start index Web instance"""
        http = make_server('', 9999, serve.index)
        self.assertTrue(http)
        http.server_close() # close the connection

class TestMapper(unittest.TestCase):
    def test_mapper(self):
        """Start mapper Web instance"""
        http = make_server('', 9999, serve.mapper)
        self.assertTrue(http)
        http.server_close() # close the connection

class TestHelloWorld(unittest.TestCase):
    def test_hello_world(self):
        """Start Hello_World Web instance"""
        http = make_server('', 9999, serve.hello_world)
        self.assertTrue(http)
        http.server_close() # close the connection

if __name__ == '__main__':
    unittest.main()